com.singularsys.jep.misc.functions

## Class SwitchDefault

- java.lang.Object
- - com.singularsys.jep.functions.PostfixMathCommand
  - - com.singularsys.jep.misc.functions.SwitchDefault

- All Implemented Interfaces:
    CallbackEvaluationI, PostfixMathCommandI, java.io.Serializable

      public class SwitchDefault
      extends PostfixMathCommand
      implements CallbackEvaluationI

  A switch statement, with a default value. The argument is selected based on the integer value of the first argument, the last argument is returned if the first argument is greater than the number of arguments -2. For example `switchDefault(2,5,6,7,8)` will return 5, and `switchDefault(9,5,6,7,8)` will return 8. The first argument must be an exact integer.
  Author:
    Richard Morris
  See Also:
    `Case`, Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SwitchDefault.NullBehaviour` Action to take if first argument is null.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected SwitchDefault.NullBehaviour` | `nullBehaviour`

    - ### Fields inherited from class com.singularsys.jep.functions.PostfixMathCommand

      `curNumberOfParameters, name, NaN, numberOfParameters`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SwitchDefault()` Default switch statement.
    `SwitchDefault(SwitchDefault.NullBehaviour nullBehaviour)` Switch function with defined null behaviour.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `checkNumberOfParameters(int n)` Checks the number of parameters of the function.
    `java.lang.Object` | `evaluate(Node node, Evaluator pv)` Performs some special evaluation on the node.
    `SwitchDefault.NullBehaviour` | `getNullBehaviour()` Behaviour when passed zero arguments.

    - ### Methods inherited from class com.singularsys.jep.functions.PostfixMathCommand

      `asArray, asBool, asDouble, asInt, asLong, asStrictInt, asString, getName, getNumberOfParameters, run, setCurNumberOfParameters, setName, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### nullBehaviour

          protected SwitchDefault.NullBehaviour nullBehaviour

  - ### Constructor Detail

    - #### SwitchDefault

          public SwitchDefault()

      Default switch statement. Exceptions are thrown if first argument is null.

    - #### SwitchDefault

          public SwitchDefault(SwitchDefault.NullBehaviour nullBehaviour)

      Switch function with defined null behaviour.
      Parameters:
        `nullBehaviour` - action to take if first argument is null.
      Since:
        Jep 3.5

  - ### Method Detail

    - #### checkNumberOfParameters

          public boolean checkNumberOfParameters(int n)

      Description copied from class: `PostfixMathCommand`
      Checks the number of parameters of the function. Functions which set numberOfParameter=-1 should overload this method
      Specified by:
        `checkNumberOfParameters` in interface `PostfixMathCommandI`
      Overrides:
        `checkNumberOfParameters` in class `PostfixMathCommand`
      Parameters:
        `n` - number of parameters function will be called with.
      Returns:
        false if an illegal number of parameters is supplied, true otherwise.

    - #### getNullBehaviour

          public SwitchDefault.NullBehaviour getNullBehaviour()

      Behaviour when passed zero arguments.
      Returns:
        code indicating behaviour type
      Since:
        Jep 3.5

    - #### evaluate

          public java.lang.Object evaluate(Node node,
                                           Evaluator pv)
                                    throws EvaluationException

      Description copied from interface: `CallbackEvaluationI`
      Performs some special evaluation on the node. This method has the responsibility for evaluating the children of the node and it should generally call

           pv.eval(node.jjtGetChild(i))

      for each child. The SymbolTable is not passed as an argument. This is because it is better practice to get and set variable values by using node.getVar().setValue() rather that through the SymbolTable with requires a hashtable lookup.
      Specified by:
        `evaluate` in interface `CallbackEvaluationI`
      Parameters:
        `node` - The current node
        `pv` - The visitor, can be used evaluate the children
      Returns:
        the value after evaluation. This value will be passed to other functions higher up the node tree. The value can be any type including Double or Vector<Object>
      Throws:
        `EvaluationException` - if the calculation cannot be performed
      See Also:
        `Evaluator`

Copyright © 2018 Singular Systems http://www.singularsys.com/jep